_G[gTable] = {};

local aTmpVal = gTable;
cm.SetupTable(_G[aTmpVal]);


-- Called on Init
_G[gTable].OnInit = function(pObj)
	pObj.mState = 0;
	pObj.mCsData:SetVal("AppearStart", 1);
	pObj.mCsData:SetVal("AppearEnd",   2);
	pObj.mCsData:SetVal("DisappearStart", 3);
	pObj.mCsData:SetVal("DisappearEnd",4);
end

-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)

end


-- Called on a update
_G[gTable].OnUpdate = function(pObj)

   -- Check if disappearing is complete
   if aState == 3 then
		if not pObj.mAlpha:AncIsChanging() then
         pObj.mState = aState + 1;
			pObj.mIsDone= true;
		end
	end

end


-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)

	pObj.mDiscovered = true;
	if pName == "" then

      cm.GetShowInfo(pObj, "InfoStr1", "InfoTime1");
      IcPlaySample("PH_SFX_DOES_NOT_WORK");
		return true;

	elseif pName == pObj.mCsData:GetString("KeyObject1") then

      if pObj.mState == 0 then

         if not cm.SpawnObject(pObj, 0, pObj.mSmPos, "SpawnObject") then
            return true;
         end

   		pObj.mState = 3;
   		pObj.mDrawer= "DrawFadeAppearDisappear";
   		pObj.mAlpha:AncSetupChange(255.0, 0.0, PhSpawnerVanishAfterUse,
            IcAutoNumChgr.IC_ANCM_LINEAR);
   		cm.DisableObject(pObj);

         cm.GetShowInfo(pObj, "InfoStr2", "InfoTime2");
   		_G[pActorObj.mScriptTag].OnUse(pActorObj, pObj);
   		return true;
		end

      cm.ShowInfo(pObj, "That might work, but not for now", 180);
		return false;

	else
		cm.ObjDoesNotWork(pObj);
		return false;
	end

	return false;

end


-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)

	local aImg  = IcImageWrap(pObj.mSmallImage);
	assert(aImg);
	local aRpos = pObj.mSmPos;
	local aRect = aImg:GetCelRect(pObj.mCurCell);

	if (pObj.mState == 2) then
		pG:SetColorizeImages(true);
		pG:SetColor(Color(255, 255, 255, pObj.mAlpha:AncGetVal()));
	end
	pG:DrawImage(aImg:GetImage(), aRpos.x, aRpos.y, aRect);

end



